#include "testApp.h"


//--------------------------------------------------------------
void testApp::setup(){	
	
	ofSetVerticalSync(true);
	ofSetFrameRate(60);
	
	for (int i = 0; i < 500; i++){
		particle myParticle;
		float angle = ofRandom(0, 2 * PI);
		float magnitude = ofRandom(3.5, 4);
		
		float x = magnitude + cos (angle);
		float y = magnitude + sin (angle);
		
//		float vx = ofRandom(-4,4);
//		float vy = ofRandom(-4,4);

		myParticle.setInitialCondition(ofGetWidth()/2, ofGetHeight()/2,x, y);
		// more interesting with diversity :)
		// uncomment this: 
		//myParticle.damping = ofRandom(0.01, 0.05);
		particles.push_back(myParticle);
	}
	
}

//--------------------------------------------------------------
void testApp::update(){

	// on every frame 
	// we reset the forces
	// add in any forces on the particle
	// perfom damping and
	// then update
	
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].resetForce();
		particles[i].addForce(0,0.35);  // gravity
		particles[i].addDampingForce();
		particles[i].update();
		particles[i].bounceOffWalls();
		
		
	}

}

//--------------------------------------------------------------
void testApp::draw(){

	ofSetColor(0x000000);
	
	for (int i = 0; i < particles.size(); i++){
		particles[i].draw();
	}

}

//--------------------------------------------------------------
void testApp::keyPressed  (int key){ 
}

//--------------------------------------------------------------
void testApp::keyReleased  (int key){ 
}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){

	}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){

	
}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){

for (int i = 0; i < particles.size(); i++){

		float angle = ofRandom(0, 2 * PI);
		float magnitude = ofRandom(4.5, -30.0);
	
		float vx = magnitude + cos (angle);
		float vy = magnitude + -sin (angle);
	

		
		particles[i].setInitialCondition(mouseX,mouseY,vx, vy);	
	}

		
}

//--------------------------------------------------------------
void testApp::mouseReleased(){
}
